%define plevelversion 1

%if %{plevelversion} >= 1
%define plevel P%{plevelversion}
%endif

Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server/relay agent/client
Name:		dhcp
Epoch:		3
Version:	4.2.4
Release:	0.P%{plevelversion}.1
License:	Distributable
Group:		System/Servers
URL:		http://www.isc.org/software/dhcp
Source0:	ftp://ftp.isc.org/isc/%{name}/%{name}-%{version}/%{name}-%{version}%{?plevel:-%{plevel}}.tar.gz
Source1:	ftp://ftp.isc.org/isc/%{name}/%{name}-%{version}/%{name}-%{version}%{?plevel:-%{plevel}}.tar.gz.sha512.asc
Source2:	dhcpd.conf
Source4:	dhcp-dynamic-dns-examples.tar.bz2
Source7:	dhcpreport.pl
Source8:	dhcpd-chroot.sh
# (eugeni) dhclient-exit-hooks script
Source9:	dhclient-exit-hooks
Source10:	draft-ietf-dhc-ldap-schema-01.txt
Source11:	dhcpd.init
Source12:	dhcpd.service
Source13:	dhcpd6.init
Source14:	dhcpd6.service
Source15:	dhcrelay.init
Source16:	dhcrelay.service
# mageia patches
Patch100:	dhcp-4.2.2-ifup.patch
Patch101:	dhcp-4.2.2-fix-format-errors.patch
# prevents needless deassociation, working around mdv bug #43441
Patch102:	dhcp-4.1.1-prevent_wireless_deassociation.patch
# fedora patches
Patch8:		dhcp-4.2.2-xen-checksum.patch
Patch15:	dhcp-4.2.2-missing-ipv6-not-fatal.patch
Patch17:	dhcp-4.2.0-add_timeout_when_NULL.patch
Patch18:	dhcp-4.2.4-64_bit_lease_parse.patch
BuildRequires:	autoconf automake libtool
BuildRequires:	groff-for-man
BuildRequires:	openldap-devel
BuildRequires:	bind-devel
%if %{mdkver} >= 201100
BuildRequires:	systemd-units
%endif

%description 
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network configuration
information (IP address, subnetmask, broadcast address, etc.) from a DHCP
server. The overall purpose of DHCP is to make it easier to administer a 
large network. The dhcp package includes the DHCP server and a DHCP relay
agent. You will also need to install the dhcp-client or dhcpcd package,
or pump or dhcpxd, which provides the DHCP client daemon, on client machines.

If you want the DHCP server and/or relay, you will also need to install the
dhcp-server and/or dhcp-relay packages.

%package	common
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server
Group:		System/Servers

%description	common
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network 
configuration information (IP address, subnetmask, broadcast address, 
etc.) from a DHCP server.  The overall purpose of DHCP is to make it 
easier to administer a large network.  The dhcp package includes the 
DHCP server and a DHCP relay agent.

You will also need to install the dhcp-client or dhcpcd package, or pump or
dhcpxd, which provides the DHCP client daemon, on  client machines. If you
want the DHCP server and/or relay, you will also need to install the
dhcp-server and/or dhcp-relay packages.

%package	doc
Summary:	Documentation about the ISC DHCP server/client
Group:		System/Servers

%description	doc
This package contains RFC/API/protocol documentation about the ISC
DHCP server and client.

DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network 
configuration information (IP address, subnetmask, broadcast address, 
etc.) from a DHCP server.  The overall purpose of DHCP is to make it 
easier to administer a large network.  The dhcp package includes the 
DHCP server and a DHCP relay agent.

%package	server
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server
Group:		System/Servers
Requires:	dhcp-common >= %{EVRD}
Requires(post):	rpm-helper
Requires(preun):rpm-helper
%if %{mdkver} >= 201100
Requires(post,postun):	systemd-units
%endif

%description	server
DHCP server is the Internet Software Consortium (ISC) DHCP server for various
UNIX operating systems. It allows a UNIX mac hine to serve DHCP requests from
the network.

You should install dhcp-server if you want to set up a DHCP server on your
network. You will also need to install the base dhcp package.

%package	client
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) client
Group:		System/Servers
Requires:	dhcp-common >= %{EVRD}
Provides:	dhcp-client-daemon

%description	client
DHCP client is the Internet Software Consortium (ISC) DHCP client for various
UNIX operating systems.  It allows a UNIX mac hine to obtain it's networking
parameters from a DHCP server.

You should install dhcp-client if you want to use the ISC DHCP client instead
of the Red Hat DHCP client, pump, or dhcpcd, or dhcpxd. You will also need to
install the base dhcp package.

%package	relay
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) relay
Group:		System/Servers
Requires:	dhcp-common >= %{EVRD}
Requires(post):	rpm-helper
Requires(preun):rpm-helper

%description	relay
DHCP relay is the Internet Software Consortium (ISC) relay agent for DHCP
packets. It is used on a subnet with DHCP clients to "relay" their requests
to a subnet that has a DHCP server on it. Because DHCP packets can be
broadcast, they will not be routed off of the local subnet. The DHCP relay
takes care of this for the client. You will need to set the environment
variable SERVERS and optionally OPTIONS in %{_sysconfdir}/sysconfig/dhcrelay before
starting the server.

%package	devel
Summary:	Development headers and libraries for the dhcpctl API
Group:		Development/Other
Requires:	dhcp-common >= %{EVRD}

%description	devel
DHCP devel contains all of the libraries and headers for developing with the
Internet Software Consortium (ISC) dhcpctl API.

%prep
%setup -q -n %{name}-%{version}%{?plevel:-%{plevel}}

%patch100 -p1 -b .ifup
%patch101 -p1 -b .format_not_a_string_literal_and_no_format_arguments
%patch102 -p1 -b .prevent_wireless_deassociation


# Handle Xen partial UDP checksums
%patch8 -p1 -b .xen
# If the ipv6 kernel module is missing, do not segfault
# (Submitted to dhcp-bugs@isc.org - [ISC-Bugs #19367])
%patch15 -p1 -b .noipv6
# Handle cases in add_timeout() where the function is called with a NULL
# value for the 'when' parameter
%patch17 -p1 -b .dracut
# Ensure 64-bit platforms parse lease file dates & times correctly
%patch18 -p1 -b .64-bit_lease_parse

# remove empty files
find -size 0 |grep ldap | xargs rm -rf 

cp %{SOURCE10} doc

%build
autoreconf -fi
%if %{mdkver} >= 201200
%serverbuild_hardened
%else
%serverbuild
%endif

%configure2_5x \
    --enable-paranoia \
    --enable-early-chroot \
    --with-ldapcrypto \
    --with-srv-lease-file=%{_localstatedir}/lib/dhcp/dhcpd.leases \
    --with-srv6-lease-file=%{_localstatedir}/lib/dhcp/dhcpd6.leases \
    --with-cli-lease-file=%{_localstatedir}/lib/dhcp/dhclient.leases \
    --with-cli6-lease-file=%{_localstatedir}/lib/dhcp/dhclient6.leases \
    --with-srv-pid-file=%{_var}/run/dhcpd/dhcpd.pid \
    --with-srv6-pid-file=%{_var}/run/dhcpd/dhcpd6.pid \
    --with-cli-pid-file=%{_var}/run/dhclient.pid \
    --with-cli6-pid-file=%{_var}/run/dhclient6.pid \
    --with-relay-pid-file=%{_var}/run/dhcrelay.pid

%make

%install
%makeinstall_std

# Install correct dhclient-script
install -p -m755 client/scripts/linux -D %{buildroot}/sbin/dhclient-script
mv %{buildroot}%{_sbindir}/dhclient %{buildroot}/sbin/dhclient

install -m644 %{SOURCE12} -D %{buildroot}%{_unitdir}/dhcpd.service
install -m644 %{SOURCE14} -D %{buildroot}%{_unitdir}/dhcpd6.service
install -m644 %{SOURCE16} -D %{buildroot}%{_unitdir}/dhcrelay.service
install -m755 %{SOURCE11} -D %{buildroot}%{_initrddir}/dhcpd
install -m755 %{SOURCE13} -D %{buildroot}%{_initrddir}/dhcpd6
install -m755 %{SOURCE15} -D %{buildroot}%{_initrddir}/dhcrelay

install -m755 %{SOURCE7} -D %{buildroot}%{_sbindir}/dhcpreport.pl
install -m755 %{SOURCE8} -D %{buildroot}%{_sbindir}/dhcpd-chroot.sh
install -m644 %{SOURCE2} -D %{buildroot}%{_sysconfdir}/dhcpd.conf
install -m755 contrib/ldap/dhcpd-conf-to-ldap -D %{buildroot}%{_sbindir}/dhcpd-conf-to-ldap

# install exit-hooks script to /etc/
install -m755 %{SOURCE9} -D %{buildroot}%{_sysconfdir}/dhclient-exit-hooks

install -d %{buildroot}%{_sysconfdir}/sysconfig
cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcpd <<EOF
# You can set here various option for dhcpd

# Which configuration file to use.
CONFIGFILE="%{_sysconfdir}/dhcpd.conf"

# Where to store the lease state information.
LEASEFILE="%{_localstatedir}/lib/dhcp/dhcpd.leases"

# Define INTERFACES to limit which network interfaces dhcpd listens on.
# The default null value causes dhcpd to listen on all interfaces.
INTERFACES=""

# Define OPTIONS with any other options to pass to the dhcpd server.
# See dhcpd(8) for available options and syntax.
OPTIONS="-q"

EOF

install -d %{buildroot}%{_localstatedir}/lib/dhcp
install -d %{buildroot}%{_var}/run/dhcpd

touch %{buildroot}%{_localstatedir}/lib/dhcp/dhcpd.leases
touch %{buildroot}%{_localstatedir}/lib/dhcp/dhclient.leases

cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcrelay <<EOF
# Define SERVERS with a list of one or more DHCP servers where
# DHCP packets are to be relayed to and from.  This is mandatory.
#SERVERS="10.11.12.13 10.9.8.7"
SERVERS=""

# Define OPTIONS with any other options to pass to the dhcrelay server.
# See dhcrelay(8) for available options and syntax.
#OPTIONS="-q -i eth0 -i eth1"
OPTIONS="-q"
EOF

find . -type d -exec chmod 0755 {} \;
find . -type f -exec chmod 0644 {} \;

rm -rf doc/ja_JP.eucJP

# remove empty files
find -size 0 |grep ldap | xargs rm -rf 

# remove unwanted file
rm -f %{buildroot}%{_sysconfdir}/dhclient.conf

%post server
%_post_service dhcpd
# New dhcpd lease file
if [ ! -f %{_localstatedir}/lib/dhcp/dhcpd.leases ]; then
    touch %{_localstatedir}/lib/dhcp/dhcpd.leases
fi

%preun server
%_preun_service dhcpd

%post relay
%_post_service dhcrelay

%preun relay
%_preun_service dhcrelay

%post client
touch %{_localstatedir}/lib/dhcp/dhclient.leases

%postun client
rm -rf %{_localstatedir}/lib/dhcp/dhclient.leases

%files common
%doc README contrib/ldap/README.ldap RELNOTES
%doc contrib/3.0b1-lease-convert
%dir %{_localstatedir}/lib/dhcp
%{_mandir}/man5/dhcp-options.5*

%files doc
%doc doc/*

%files server
%doc server/dhcpd.conf tests/failover contrib/ldap/dhcp.schema
%{_unitdir}/dhcpd.service
%{_unitdir}/dhcpd6.service
%{_initrddir}/dhcpd
%{_initrddir}/dhcpd6
%config(noreplace) %{_sysconfdir}/dhcpd.conf
%config(noreplace) %{_sysconfdir}/dhclient-exit-hooks
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd
%config(noreplace) %ghost %{_localstatedir}/lib/dhcp/dhcpd.leases
%{_sbindir}/dhcpd
%{_sbindir}/dhcpreport.pl
%{_sbindir}/dhcpd-conf-to-ldap
%{_sbindir}/dhcpd-chroot.sh
%{_bindir}/omshell
%{_mandir}/man1/omshell.1*
%{_mandir}/man5/dhcpd.conf.5*
%{_mandir}/man5/dhcpd.leases.5*
%{_mandir}/man5/dhcp-eval.5*
%{_mandir}/man8/dhcpd.8*
%dir %{_var}/run/dhcpd

%files relay
%{_unitdir}/dhcrelay.service
%{_initrddir}/dhcrelay

%config(noreplace) %{_sysconfdir}/sysconfig/dhcrelay
%{_sbindir}/dhcrelay
%{_mandir}/man8/dhcrelay.8*

%files client
%doc client/dhclient.conf
%config(noreplace) %ghost %{_localstatedir}/lib/dhcp/dhclient.leases
%attr (0755,root,root) /sbin/dhclient-script
/sbin/dhclient
%{_mandir}/man5/dhclient.conf.5*
%{_mandir}/man5/dhclient.leases.5*
%{_mandir}/man8/dhclient.8*
%{_mandir}/man8/dhclient-script.8*

%files devel
%{_includedir}/*
%{_libdir}/*.a
%{_mandir}/man3/*


%changelog
* Fri Jul 27 2012 Oden Eriksson <oeriksson@mandriva.com> 3:4.2.4-0.P1.1
+ Revision: 811205
- fix build
- 4.2.4-P1

* Mon May 28 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 3:4.2.3-1.P2.3
+ Revision: 800879
- untill we've decided to sys v init compatibility completely, install init
  scripts in parallel with systemd services
- really clean up..
- clean out some junk
- use %%{EVRD} macro
- provide 'dhcp-client-daemon'

* Sun Jan 15 2012 Tomasz Pawel Gajc <tpg@mandriva.org> 3:4.2.3-1.P2.2
+ Revision: 761630
- adjust spec file and services file for systemd

* Sun Jan 15 2012 Tomasz Pawel Gajc <tpg@mandriva.org> 3:4.2.3-1.P2.1
+ Revision: 761129
- update to new version dhcp-4.2.3-P2
- use %%serverbuild_hardened
- add requires(post,preun) on ystemd-units in server subpackage

* Thu Dec 08 2011 Oden Eriksson <oeriksson@mandriva.com> 3:4.2.3-1.P1.1
+ Revision: 739067
- fix volatile rpm5 changes (does it never end?)
- 4.2.3-P1 (fixes CVE-2011-4539)
- added better logic to handle the patch levels, set 0 (zero) for a "fake" -P0 version
- various cleanups

* Sun Nov 20 2011 Oden Eriksson <oeriksson@mandriva.com> 3:4.2.3-0
+ Revision: 732029
- 4.2.3 (slight mageia sync, needs further systemd work though)

* Thu Aug 18 2011 Oden Eriksson <oeriksson@mandriva.com> 3:4.2.1-0.P1.2
+ Revision: 695144
- actually use the correct friggin patch...
- P10: security fix for CVE-2011-2748,2749

* Fri Apr 08 2011 Oden Eriksson <oeriksson@mandriva.com> 3:4.2.1-0.P1.1
+ Revision: 651971
- 4.2.1-P1
- drop one upstream added patch

* Wed Jan 19 2011 Eugeni Dodonov <eugeni@mandriva.com> 3:4.2.0-0.P2.2
+ Revision: 631680
- Added sample dhclient-exit-hooks, initially handling
  rfc3442_classless_static_routes (suggested in #62242).

* Thu Jan 06 2011 Oden Eriksson <oeriksson@mandriva.com> 3:4.2.0-0.P2.1mdv2011.0
+ Revision: 629100
- 4.2.0-P2
- bump release
- 4.2.0-P1

* Mon Aug 30 2010 Olivier Blin <blino@mandriva.org> 2:4.2.0-1mdv2011.0
+ Revision: 574440
- do not define again _GNU_SOURCE, now defined in default configure script
- 4.2.0
- LDAP patch merged upstream

* Mon Jul 12 2010 Eugeni Dodonov <eugeni@mandriva.com> 2:4.1.1-7mdv2011.0
+ Revision: 551267
- Get rid of some useless wait (rh bug #587070)

* Fri Jun 11 2010 Oden Eriksson <oeriksson@mandriva.com> 2:4.1.1-6mdv2010.1
+ Revision: 547867
- 4.1.1-P1

* Tue Apr 06 2010 Funda Wang <fwang@mandriva.org> 2:4.1.1-5mdv2010.1
+ Revision: 531983
- rebuild for new openssl

* Fri Mar 12 2010 Götz Waschk <waschk@mandriva.org> 2:4.1.1-4mdv2010.1
+ Revision: 518419
- remove debug files from devel package

* Tue Mar 09 2010 Guillaume Rousse <guillomovitch@mandriva.org> 2:4.1.1-3mdv2010.1
+ Revision: 517076
- set explicit runlevels in init script

* Fri Feb 26 2010 Oden Eriksson <oeriksson@mandriva.com> 2:4.1.1-2mdv2010.1
+ Revision: 511559
- rebuilt against openssl-0.9.8m

* Thu Feb 25 2010 Eugeni Dodonov <eugeni@mandriva.com> 2:4.1.1-1mdv2010.1
+ Revision: 511131
- Updated to 4.1.1.
  Rediff P0, P5, P6, P7.
  Drop P9 (merged upstream).
  Drop P10 (no longer needed).

* Wed Feb 17 2010 Eugeni Dodonov <eugeni@mandriva.com> 2:4.1.0p1-4mdv2010.1
+ Revision: 507051
- Updated ldap patch to use correct variables (#56028).

* Tue Jan 26 2010 Eugeni Dodonov <eugeni@mandriva.com> 2:4.1.0p1-3mdv2010.1
+ Revision: 496733
- Allow setting MTU if specified by the server (#57260).

* Wed Sep 23 2009 Oden Eriksson <oeriksson@mandriva.com> 2:4.1.0p1-2mdv2010.0
+ Revision: 447689
- P9: security fix for CVE-2009-1892

* Wed Jul 15 2009 Oden Eriksson <oeriksson@mandriva.com> 2:4.1.0p1-1mdv2010.0
+ Revision: 396413
- 4.1.0p1

* Fri Jun 19 2009 Wanderlei Cavassin <cavassin@mandriva.com.br> 2:4.1.0-6mdv2010.0
+ Revision: 387320
- fixed lease file parsing for tokens never and epoch (closes mdv #50194)

  + Götz Waschk <waschk@mandriva.org>
    - fix URL

* Wed Mar 04 2009 Gustavo De Nardin <gustavodn@mandriva.com> 2:4.1.0-5mdv2009.1
+ Revision: 348205
- added Patch7, as suggested by Andrey Borzenkov, which prevents
  dhclient-script from bringing interfaces down needlessly, which in turn
  works around bug #43441 (deassociation going unnoticed by wpa_supplicant,
  in the end causing the interface to not get an IP address)

* Thu Feb 19 2009 Frederic Crozat <fcrozat@mandriva.com> 2:4.1.0-4mdv2009.1
+ Revision: 342950
- Update patch6 with Fedora version which has been submitted upstream for inclusion

* Fri Jan 09 2009 Frederic Crozat <fcrozat@mandriva.com> 2:4.1.0-3mdv2009.1
+ Revision: 327771
- Patch6: no IPv6 is no longer a fatal error for dhclient

* Thu Jan 08 2009 Frederic Crozat <fcrozat@mandriva.com> 2:4.1.0-2mdv2009.1
+ Revision: 327169
- Update patch0 to correctly work with resolvconf

* Thu Jan 08 2009 Frederic Crozat <fcrozat@mandriva.com> 2:4.1.0-1mdv2009.1
+ Revision: 327047
- Release 4.1.0 (Mdv bug #46804)
- Remove detection of 64bits host at buildtime, configure is smart enough now
- Enable IPv6 support
- Regenerate patches 0, 5
- Remove patches 2 (merged upstream), 4 (useless)
- Patch1 (LDAP support) is now taked from Fedora, as well as source 9, 10, 11, 12

* Sat Dec 20 2008 Oden Eriksson <oeriksson@mandriva.com> 2:3.0.7-2mdv2009.1
+ Revision: 316549
- rediffed one fuzzy patch
- fix build with -Werror=format-security (P5)

* Sun Jul 13 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 2:3.0.7-1mdv2009.0
+ Revision: 234269
- update to new version 3.0.7
- Patch1: new version
- use %%_var instead of %%_localstatedir
- spec file clean

* Mon Jun 16 2008 Thierry Vignaud <tv@mandriva.org> 2:3.0.6-6mdv2009.0
+ Revision: 220615
- rebuild

  + Pixel <pixel@mandriva.com>
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Wed Mar 26 2008 Oden Eriksson <oeriksson@mandriva.com> 2:3.0.6-5mdv2008.1
+ Revision: 190309
- don't start it per default

* Wed Jan 23 2008 Thierry Vignaud <tv@mandriva.org> 2:3.0.6-4mdv2008.1
+ Revision: 157246
- rebuild with fixed %%serverbuild macro

* Mon Dec 24 2007 Oden Eriksson <oeriksson@mandriva.com> 2:3.0.6-3mdv2008.1
+ Revision: 137459
- rebuilt against openldap-2.4.7 libs

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot
    - fix typo in doc description

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Dec 12 2007 Olivier Blin <blino@mandriva.org> 2:3.0.6-2mdv2008.1
+ Revision: 119077
- move rpm-helper requirements in post/preun instead of pre/postun when needed

* Tue Jul 10 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 2:3.0.6-1mdv2008.0
+ Revision: 50797
- new version

* Wed Jul 04 2007 Andreas Hasenack <andreas@mandriva.com> 2:3.0.5-8mdv2008.0
+ Revision: 48227
- use serverbuild macro (-fstack-protector-all)

